# Chrome Speed

## Contact information

  * **Contact**: **speed@chromium.org**
  * **Escalation**:
    * benhenry@chromium.org (TPM)
  * **File a bug**: [template](https://bugs.chromium.org/p/chromium/issues/entry?template=Speed%20Bug)
  * **Regression postmortem**: [template](https://docs.google.com/document/d/1fvfhFNOoUL9rB0XAEe1MYefyM_9yriR1IPjdxdm7PaQ/edit?disco=AAAABKdHwCg)

## User Docs

  * [How does Chrome measure performance?](how_does_chrome_measure_performance.md)
  * [My CL caused a performance regression! What do I do?](addressing_performance_regressions.md)
  * [I want Chrome to have better performance](help_improve_performance.md)
  * [Perf sheriffing documentation](perf_regression_sheriffing.md)
  * [I want to add tests or platforms to the perf waterfall](adding_tests_bots.md)

## Core Teams and Work

  * **[Speed domain area experts](speed_domains.md)**: These mailing lists and
    bug triage rotations provide expertise into specific domain areas of Speed:
    memory, power, loading, responsiveness, binary size, data usage, and browser
    UI.
  * **[Chrome Speed Operations](chrome_speed_operations.md)**: provides the
    benchmarks, infrastructure, and releasing oversight to track regressions.
    <!--- TODO: General discussion: chrome-speed-operations mailing list link -->
    <!--- TODO: Tracking releases and regressions: chrome-speed-releasing mailing list link -->
    * Benchmark-specific discussion: benchmarking-dev@chromium.org
    <!--- TODO: Requests for new benchmarks: chrome-benchmarking-request mailing list link -->
    * Performance dashboard, bisect, try jobs: speed-services-dev@chromium.org
  * **[Chrome Speed Metrics](../speed_metrics/README.md)**: provides a set of high-quality metrics that represent real-world user experience, and exposes these metrics to both Chrome and Web Developers.
    * General discussion: speed-metrics-dev@chromium.org
    * The actual metrics: [speed launch metrics survey.](https://docs.google.com/document/d/1Ww487ZskJ-xBmJGwPO-XPz_QcJvw-kSNffm0nPhVpj8/edit#heading=h.2uunmi119swk)
